import{S as Tc,i as kc,s as Dc,e as r,k as i,w as v,t as s,M as Oc,c as o,d as t,m as p,a as n,x as $,h as a,b as T,G as e,g as j,y as b,q as E,o as w,B as y,v as Lc,L as Ie}from"../../chunks/vendor-hf-doc-builder.js";import{D as q}from"../../chunks/Docstring-hf-doc-builder.js";import{C as qe}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Ac}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Ne}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Cc(O){let d,g,f,h,u;return h=new qe({props:{code:`from accelerate.state import PartialState

state = PartialState()
with state.local_main_process_first():
    # This will be printed first by local process 0 then in a seemingly
    # random order by the other processes.
    print(f"This will be printed by process {state.local_process_index}")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate.state <span class="hljs-keyword">import</span> PartialState

<span class="hljs-meta">&gt;&gt;&gt; </span>state = PartialState()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> state.local_main_process_first():
<span class="hljs-meta">... </span>    <span class="hljs-comment"># This will be printed first by local process 0 then in a seemingly</span>
<span class="hljs-meta">... </span>    <span class="hljs-comment"># random order by the other processes.</span>
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;This will be printed by process <span class="hljs-subst">{state.local_process_index}</span>&quot;</span>)`}}),{c(){d=r("p"),g=s("Example:"),f=i(),v(h.$$.fragment)},l(l){d=o(l,"P",{});var m=n(d);g=a(m,"Example:"),m.forEach(t),f=p(l),$(h.$$.fragment,l)},m(l,m){j(l,d,m),e(d,g),j(l,f,m),b(h,l,m),u=!0},p:Ie,i(l){u||(E(h.$$.fragment,l),u=!0)},o(l){w(h.$$.fragment,l),u=!1},d(l){l&&t(d),l&&t(f),y(h,l)}}}function Nc(O){let d,g,f,h,u;return h=new qe({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
with accelerator.main_process_first():
    # This will be printed first by process 0 then in a seemingly
    # random order by the other processes.
    print(f"This will be printed by process {accelerator.process_index}")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.main_process_first():
<span class="hljs-meta">... </span>    <span class="hljs-comment"># This will be printed first by process 0 then in a seemingly</span>
<span class="hljs-meta">... </span>    <span class="hljs-comment"># random order by the other processes.</span>
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;This will be printed by process <span class="hljs-subst">{accelerator.process_index}</span>&quot;</span>)`}}),{c(){d=r("p"),g=s("Example:"),f=i(),v(h.$$.fragment)},l(l){d=o(l,"P",{});var m=n(d);g=a(m,"Example:"),m.forEach(t),f=p(l),$(h.$$.fragment,l)},m(l,m){j(l,d,m),e(d,g),j(l,f,m),b(h,l,m),u=!0},p:Ie,i(l){u||(E(h.$$.fragment,l),u=!0)},o(l){w(h.$$.fragment,l),u=!1},d(l){l&&t(d),l&&t(f),y(h,l)}}}function Ic(O){let d,g,f,h,u;return h=new qe({props:{code:`# Assume we have 4 processes.
from accelerate.state import PartialState

state = PartialState()


@state.on_last_process
def print_something():
    print(f"Printed on process {state.process_index}")


print_something()
"Printed on process 3"`,highlighted:`<span class="hljs-comment"># Assume we have 4 processes.</span>
<span class="hljs-keyword">from</span> accelerate.state <span class="hljs-keyword">import</span> PartialState

state = PartialState()


<span class="hljs-meta">@state.on_last_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Printed on process <span class="hljs-subst">{state.process_index}</span>&quot;</span>)


print_something()
<span class="hljs-string">&quot;Printed on process 3&quot;</span>`}}),{c(){d=r("p"),g=s("Example:"),f=i(),v(h.$$.fragment)},l(l){d=o(l,"P",{});var m=n(d);g=a(m,"Example:"),m.forEach(t),f=p(l),$(h.$$.fragment,l)},m(l,m){j(l,d,m),e(d,g),j(l,f,m),b(h,l,m),u=!0},p:Ie,i(l){u||(E(h.$$.fragment,l),u=!0)},o(l){w(h.$$.fragment,l),u=!1},d(l){l&&t(d),l&&t(f),y(h,l)}}}function qc(O){let d,g,f,h,u;return h=new qe({props:{code:`# Assume we have 2 servers with 4 processes each.
from accelerate.state import PartialState

state = PartialState()


@state.on_local_main_process
def print_something():
    print("This will be printed by process 0 only on each server.")


print_something()
# On server 1:
"This will be printed by process 0 only"
# On server 2:
"This will be printed by process 0 only"`,highlighted:`<span class="hljs-comment"># Assume we have 2 servers with 4 processes each.</span>
<span class="hljs-keyword">from</span> accelerate.state <span class="hljs-keyword">import</span> PartialState

state = PartialState()


<span class="hljs-meta">@state.on_local_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;This will be printed by process 0 only on each server.&quot;</span>)


print_something()
<span class="hljs-comment"># On server 1:</span>
<span class="hljs-string">&quot;This will be printed by process 0 only&quot;</span>
<span class="hljs-comment"># On server 2:</span>
<span class="hljs-string">&quot;This will be printed by process 0 only&quot;</span>`}}),{c(){d=r("p"),g=s("Example:"),f=i(),v(h.$$.fragment)},l(l){d=o(l,"P",{});var m=n(d);g=a(m,"Example:"),m.forEach(t),f=p(l),$(h.$$.fragment,l)},m(l,m){j(l,d,m),e(d,g),j(l,f,m),b(h,l,m),u=!0},p:Ie,i(l){u||(E(h.$$.fragment,l),u=!0)},o(l){w(h.$$.fragment,l),u=!1},d(l){l&&t(d),l&&t(f),y(h,l)}}}function Gc(O){let d,g,f,h,u;return h=new qe({props:{code:`# Assume we have 2 servers with 4 processes each.
from accelerate import Accelerator

accelerator = Accelerator()


@accelerator.on_local_process(local_process_index=2)
def print_something():
    print(f"Printed on process {accelerator.local_process_index}")


print_something()
# On server 1:
"Printed on process 2"
# On server 2:
"Printed on process 2"`,highlighted:`<span class="hljs-comment"># Assume we have 2 servers with 4 processes each.</span>
<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

accelerator = Accelerator()


<span class="hljs-meta">@accelerator.on_local_process(<span class="hljs-params">local_process_index=<span class="hljs-number">2</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Printed on process <span class="hljs-subst">{accelerator.local_process_index}</span>&quot;</span>)


print_something()
<span class="hljs-comment"># On server 1:</span>
<span class="hljs-string">&quot;Printed on process 2&quot;</span>
<span class="hljs-comment"># On server 2:</span>
<span class="hljs-string">&quot;Printed on process 2&quot;</span>`}}),{c(){d=r("p"),g=s("Example:"),f=i(),v(h.$$.fragment)},l(l){d=o(l,"P",{});var m=n(d);g=a(m,"Example:"),m.forEach(t),f=p(l),$(h.$$.fragment,l)},m(l,m){j(l,d,m),e(d,g),j(l,f,m),b(h,l,m),u=!0},p:Ie,i(l){u||(E(h.$$.fragment,l),u=!0)},o(l){w(h.$$.fragment,l),u=!1},d(l){l&&t(d),l&&t(f),y(h,l)}}}function Rc(O){let d,g,f,h,u;return h=new qe({props:{code:`from accelerate.state import PartialState

state = PartialState()


@state.on_main_process
def print_something():
    print("This will be printed by process 0 only.")


print_something()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate.state <span class="hljs-keyword">import</span> PartialState

<span class="hljs-meta">&gt;&gt;&gt; </span>state = PartialState()


<span class="hljs-meta">&gt;&gt;&gt; </span>@state.on_main_process
<span class="hljs-meta">... </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;This will be printed by process 0 only.&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span>print_something()
<span class="hljs-string">&quot;This will be printed by process 0 only&quot;</span>`}}),{c(){d=r("p"),g=s("Example:"),f=i(),v(h.$$.fragment)},l(l){d=o(l,"P",{});var m=n(d);g=a(m,"Example:"),m.forEach(t),f=p(l),$(h.$$.fragment,l)},m(l,m){j(l,d,m),e(d,g),j(l,f,m),b(h,l,m),u=!0},p:Ie,i(l){u||(E(h.$$.fragment,l),u=!0)},o(l){w(h.$$.fragment,l),u=!1},d(l){l&&t(d),l&&t(f),y(h,l)}}}function Wc(O){let d,g,f,h,u;return h=new qe({props:{code:`# Assume we have 4 processes.
from accelerate.state import PartialState

state = PartialState()


@state.on_process(process_index=2)
def print_something():
    print(f"Printed on process {state.process_index}")


print_something()
"Printed on process 2"`,highlighted:`<span class="hljs-comment"># Assume we have 4 processes.</span>
<span class="hljs-keyword">from</span> accelerate.state <span class="hljs-keyword">import</span> PartialState

state = PartialState()


<span class="hljs-meta">@state.on_process(<span class="hljs-params">process_index=<span class="hljs-number">2</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Printed on process <span class="hljs-subst">{state.process_index}</span>&quot;</span>)


print_something()
<span class="hljs-string">&quot;Printed on process 2&quot;</span>`}}),{c(){d=r("p"),g=s("Example:"),f=i(),v(h.$$.fragment)},l(l){d=o(l,"P",{});var m=n(d);g=a(m,"Example:"),m.forEach(t),f=p(l),$(h.$$.fragment,l)},m(l,m){j(l,d,m),e(d,g),j(l,f,m),b(h,l,m),u=!0},p:Ie,i(l){u||(E(h.$$.fragment,l),u=!0)},o(l){w(h.$$.fragment,l),u=!1},d(l){l&&t(d),l&&t(f),y(h,l)}}}function Vc(O){let d,g,f,h,u;return h=new qe({props:{code:`# Assuming two GPU processes
import time
from accelerate.state import PartialState

state = PartialState()
if state.is_main_process:
    time.sleep(2)
else:
    print("I'm waiting for the main process to finish its sleep...")
state.wait_for_everyone()
# Should print on every process at the same time
print("Everyone is here")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two GPU processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> time
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate.state <span class="hljs-keyword">import</span> PartialState

<span class="hljs-meta">&gt;&gt;&gt; </span>state = PartialState()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">if</span> state.is_main_process:
<span class="hljs-meta">... </span>    time.sleep(<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">else</span>:
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;I&#x27;m waiting for the main process to finish its sleep...&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>state.wait_for_everyone()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Should print on every process at the same time</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;Everyone is here&quot;</span>)`}}),{c(){d=r("p"),g=s("Example:"),f=i(),v(h.$$.fragment)},l(l){d=o(l,"P",{});var m=n(d);g=a(m,"Example:"),m.forEach(t),f=p(l),$(h.$$.fragment,l)},m(l,m){j(l,d,m),e(d,g),j(l,f,m),b(h,l,m),u=!0},p:Ie,i(l){u||(E(h.$$.fragment,l),u=!0)},o(l){w(h.$$.fragment,l),u=!1},d(l){l&&t(d),l&&t(f),y(h,l)}}}function zc(O){let d,g,f,h,u,l,m,dt,_a,ha,Y,va,Ge,$a,ba,da,et,Ea,ma,x,Re,wa,Q,ya,mt,xa,ja,ft,Sa,Pa,Ta,ut,gt,ka,Da,k,Z,_t,Oa,La,vt,Aa,Ca,Na,ee,$t,Ia,qa,tt,Ga,Ra,Wa,te,bt,Va,za,Et,Ua,Ba,Ma,se,wt,Fa,Ha,yt,Ja,Ka,Qa,ae,xt,Xa,Ya,jt,Za,er,tr,re,St,sr,ar,Pt,rr,or,nr,oe,Tt,lr,cr,kt,ir,pr,hr,ne,Dt,dr,mr,Ot,fr,ur,gr,le,Lt,_r,vr,At,$r,br,Er,G,We,wr,Ct,yr,xr,Nt,jr,Sr,ce,Pr,R,Ve,Tr,It,kr,Dr,qt,Or,Lr,ie,Ar,z,ze,Cr,Gt,Nr,Ir,pe,qr,U,Ue,Gr,Rt,Rr,Wr,he,Vr,B,Be,zr,Wt,Ur,Br,de,Mr,M,Me,Fr,Vt,Hr,Jr,me,Kr,F,Fe,Qr,zt,Xr,Yr,fe,Zr,H,He,eo,Ut,to,so,ue,fa,A,Je,ao,Bt,ro,oo,Mt,Ft,no,lo,P,ge,Ht,co,io,Jt,po,ho,mo,_e,Kt,fo,uo,st,go,_o,vo,W,Qt,$o,bo,Xt,Eo,wo,Yt,yo,xo,Zt,jo,So,Po,ve,es,To,ko,ts,Do,Oo,Lo,$e,ss,Ao,Co,as,No,Io,qo,be,rs,Go,Ro,os,Wo,Vo,zo,Ee,ns,Uo,Bo,ls,Mo,Fo,Ho,we,cs,Jo,Ko,is,Qo,Xo,Yo,ye,ps,Zo,en,hs,tn,sn,an,xe,ds,rn,on,ms,nn,ln,cn,J,Ke,pn,fs,hn,dn,us,mn,fn,K,Qe,un,gs,gn,_n,_s,vn,ua,I,Xe,$n,vs,bn,En,$s,bs,wn,yn,C,je,Es,xn,jn,ws,Sn,Pn,Tn,Se,ys,kn,Dn,xs,On,Ln,An,Pe,js,Cn,Nn,Ss,In,qn,Gn,Te,Ps,Rn,Wn,Ts,Vn,zn,Un,ke,ks,Bn,Mn,Ds,Fn,Hn,Jn,De,Os,Kn,Qn,Ls,Xn,Yn,Zn,Oe,As,el,tl,Cs,sl,al,ga;return l=new Ac({}),Re=new q({props:{name:"class accelerate.PartialState",anchor:"accelerate.PartialState",parameters:[{name:"cpu",val:": bool = False"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/state.py#L58"}}),We=new q({props:{name:"local_main_process_first",anchor:"accelerate.PartialState.local_main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/state.py#L311"}}),ce=new Ne({props:{anchor:"accelerate.PartialState.local_main_process_first.example",$$slots:{default:[Cc]},$$scope:{ctx:O}}}),Ve=new q({props:{name:"main_process_first",anchor:"accelerate.PartialState.main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/state.py#L290"}}),ie=new Ne({props:{anchor:"accelerate.PartialState.main_process_first.example",$$slots:{default:[Nc]},$$scope:{ctx:O}}}),ze=new q({props:{name:"on_last_process",anchor:"accelerate.PartialState.on_last_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any]"}],parametersDescription:[{anchor:"accelerate.PartialState.on_last_process.function",description:"<strong>function</strong> (<code>Callable</code>) &#x2014; The function to decorate.",name:"function"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/state.py#L393"}}),pe=new Ne({props:{anchor:"accelerate.PartialState.on_last_process.example",$$slots:{default:[Ic]},$$scope:{ctx:O}}}),Ue=new q({props:{name:"on_local_main_process",anchor:"accelerate.PartialState.on_local_main_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"}],parametersDescription:[{anchor:"accelerate.PartialState.on_local_main_process.function",description:"<strong>function</strong> (<code>Callable</code>) &#x2014; The function to decorate.",name:"function"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/state.py#L362"}}),he=new Ne({props:{anchor:"accelerate.PartialState.on_local_main_process.example",$$slots:{default:[qc]},$$scope:{ctx:O}}}),Be=new q({props:{name:"on_local_process",anchor:"accelerate.PartialState.on_local_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"},{name:"local_process_index",val:": int = None"}],parametersDescription:[{anchor:"accelerate.PartialState.on_local_process.function",description:`<strong>function</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
The function to decorate.`,name:"function"},{anchor:"accelerate.PartialState.on_local_process.local_process_index",description:`<strong>local_process_index</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The index of the local process on which to run the function.`,name:"local_process_index"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/state.py#L454"}}),de=new Ne({props:{anchor:"accelerate.PartialState.on_local_process.example",$$slots:{default:[Gc]},$$scope:{ctx:O}}}),Me=new q({props:{name:"on_main_process",anchor:"accelerate.PartialState.on_main_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"}],parametersDescription:[{anchor:"accelerate.PartialState.on_main_process.function",description:"<strong>function</strong> (<code>Callable</code>) &#x2014; The function to decorate.",name:"function"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/state.py#L332"}}),me=new Ne({props:{anchor:"accelerate.PartialState.on_main_process.example",$$slots:{default:[Rc]},$$scope:{ctx:O}}}),Fe=new q({props:{name:"on_process",anchor:"accelerate.PartialState.on_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"},{name:"process_index",val:": int = None"}],parametersDescription:[{anchor:"accelerate.PartialState.on_process.function",description:`<strong>function</strong> (<code>Callable</code>, <code>optional</code>) &#x2014;
The function to decorate.`,name:"function"},{anchor:"accelerate.PartialState.on_process.process_index",description:`<strong>process_index</strong> (<code>int</code>, <code>optional</code>) &#x2014;
The index of the process on which to run the function.`,name:"process_index"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/state.py#L421"}}),fe=new Ne({props:{anchor:"accelerate.PartialState.on_process.example",$$slots:{default:[Wc]},$$scope:{ctx:O}}}),He=new q({props:{name:"wait_for_everyone",anchor:"accelerate.PartialState.wait_for_everyone",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/state.py#L249"}}),ue=new Ne({props:{anchor:"accelerate.PartialState.wait_for_everyone.example",$$slots:{default:[Vc]},$$scope:{ctx:O}}}),Je=new q({props:{name:"class accelerate.state.AcceleratorState",anchor:"accelerate.state.AcceleratorState",parameters:[{name:"mixed_precision",val:": str = None"},{name:"cpu",val:": bool = False"},{name:"dynamo_plugin",val:" = None"},{name:"deepspeed_plugin",val:" = None"},{name:"fsdp_plugin",val:" = None"},{name:"megatron_lm_plugin",val:" = None"},{name:"ipex_plugin",val:" = None"},{name:"_from_accelerator",val:": bool = False"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/state.py#L511"}}),Ke=new q({props:{name:"local_main_process_first",anchor:"accelerate.state.AcceleratorState.local_main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/state.py#L694"}}),Qe=new q({props:{name:"main_process_first",anchor:"accelerate.state.AcceleratorState.main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/state.py#L684"}}),Xe=new q({props:{name:"class accelerate.state.GradientState",anchor:"accelerate.state.GradientState",parameters:[{name:"gradient_accumulation_plugin",val:": typing.Optional[accelerate.utils.dataclasses.GradientAccumulationPlugin] = None"}],source:"https://github.com/huggingface/accelerate/blob/v0.19.0/src/accelerate/state.py#L708"}}),{c(){d=r("meta"),g=i(),f=r("h1"),h=r("a"),u=r("span"),v(l.$$.fragment),m=i(),dt=r("span"),_a=s("Stateful Classes"),ha=i(),Y=r("p"),va=s("Below are variations of a "),Ge=r("a"),$a=s("singleton class"),ba=s(` in the sense that all
instances share the same state, which is initialized on the first instantiation.`),da=i(),et=r("p"),Ea=s(`These classes are immutable and store information about certain configurations or
states.`),ma=i(),x=r("div"),v(Re.$$.fragment),wa=i(),Q=r("p"),ya=s(`Singleton class that has information about the current training environment and functions to help with process
control. Designed to be used when only process control and device execution states are needed. Does `),mt=r("em"),xa=s("not"),ja=s(` need to
be initialized from `),ft=r("code"),Sa=s("Accelerator"),Pa=s("."),Ta=i(),ut=r("p"),gt=r("strong"),ka=s("Available attributes:"),Da=i(),k=r("ul"),Z=r("li"),_t=r("strong"),Oa=s("device"),La=s(" ("),vt=r("code"),Aa=s("torch.device"),Ca=s(") \u2014 The device to use."),Na=i(),ee=r("li"),$t=r("strong"),Ia=s("distributed_type"),qa=s(" ("),tt=r("a"),Ga=s("DistributedType"),Ra=s(`) \u2014 The type of distributed environment currently
in use.`),Wa=i(),te=r("li"),bt=r("strong"),Va=s("local_process_index"),za=s(" ("),Et=r("code"),Ua=s("int"),Ba=s(") \u2014 The index of the current process on the current server."),Ma=i(),se=r("li"),wt=r("strong"),Fa=s("mixed_precision"),Ha=s(" ("),yt=r("code"),Ja=s("str"),Ka=s(`) \u2014 Whether or not the current script will use mixed precision, and if so the type
of mixed precision being performed.`),Qa=i(),ae=r("li"),xt=r("strong"),Xa=s("num_processes"),Ya=s(" ("),jt=r("code"),Za=s("int"),er=s(") \u2014 The number of processes currently launched in parallel."),tr=i(),re=r("li"),St=r("strong"),sr=s("process_index"),ar=s(" ("),Pt=r("code"),rr=s("int"),or=s(") \u2014 The index of the current process."),nr=i(),oe=r("li"),Tt=r("strong"),lr=s("is_last_process"),cr=s(" ("),kt=r("code"),ir=s("bool"),pr=s(") \u2014 Whether or not the current process is the last one."),hr=i(),ne=r("li"),Dt=r("strong"),dr=s("is_main_process"),mr=s(" ("),Ot=r("code"),fr=s("bool"),ur=s(") \u2014 Whether or not the current process is the main one."),gr=i(),le=r("li"),Lt=r("strong"),_r=s("is_local_main_process"),vr=s(" ("),At=r("code"),$r=s("bool"),br=s(") \u2014 Whether or not the current process is the main one on the local node."),Er=i(),G=r("div"),v(We.$$.fragment),wr=i(),Ct=r("p"),yr=s("Lets the local main process go inside a with block."),xr=i(),Nt=r("p"),jr=s("The other processes will enter the with block after the main process exits."),Sr=i(),v(ce.$$.fragment),Pr=i(),R=r("div"),v(Ve.$$.fragment),Tr=i(),It=r("p"),kr=s("Lets the main process go first inside a with block."),Dr=i(),qt=r("p"),Or=s("The other processes will enter the with block after the main process exits."),Lr=i(),v(ie.$$.fragment),Ar=i(),z=r("div"),v(ze.$$.fragment),Cr=i(),Gt=r("p"),Nr=s("Decorator that only runs the decorated function on the last process."),Ir=i(),v(pe.$$.fragment),qr=i(),U=r("div"),v(Ue.$$.fragment),Gr=i(),Rt=r("p"),Rr=s("Decorator that only runs the decorated function on the local main process."),Wr=i(),v(he.$$.fragment),Vr=i(),B=r("div"),v(Be.$$.fragment),zr=i(),Wt=r("p"),Ur=s("Decorator that only runs the decorated function on the process with the given index on the current node."),Br=i(),v(de.$$.fragment),Mr=i(),M=r("div"),v(Me.$$.fragment),Fr=i(),Vt=r("p"),Hr=s("Decorator that only runs the decorated function on the main process."),Jr=i(),v(me.$$.fragment),Kr=i(),F=r("div"),v(Fe.$$.fragment),Qr=i(),zt=r("p"),Xr=s("Decorator that only runs the decorated function on the process with the given index."),Yr=i(),v(fe.$$.fragment),Zr=i(),H=r("div"),v(He.$$.fragment),eo=i(),Ut=r("p"),to=s(`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),so=i(),v(ue.$$.fragment),fa=i(),A=r("div"),v(Je.$$.fragment),ao=i(),Bt=r("p"),ro=s("Singleton class that has information about the current training environment."),oo=i(),Mt=r("p"),Ft=r("strong"),no=s("Available attributes:"),lo=i(),P=r("ul"),ge=r("li"),Ht=r("strong"),co=s("device"),io=s(" ("),Jt=r("code"),po=s("torch.device"),ho=s(") \u2014 The device to use."),mo=i(),_e=r("li"),Kt=r("strong"),fo=s("distributed_type"),uo=s(" ("),st=r("a"),go=s("DistributedType"),_o=s(`) \u2014 The type of distributed environment currently
in use.`),vo=i(),W=r("li"),Qt=r("strong"),$o=s("initialized"),bo=s(" ("),Xt=r("code"),Eo=s("bool"),wo=s(") \u2014 Whether or not the "),Yt=r("code"),yo=s("AcceleratorState"),xo=s(" has been initialized from "),Zt=r("code"),jo=s("Accelerator"),So=s("."),Po=i(),ve=r("li"),es=r("strong"),To=s("local_process_index"),ko=s(" ("),ts=r("code"),Do=s("int"),Oo=s(") \u2014 The index of the current process on the current server."),Lo=i(),$e=r("li"),ss=r("strong"),Ao=s("mixed_precision"),Co=s(" ("),as=r("code"),No=s("str"),Io=s(`) \u2014 Whether or not the current script will use mixed precision, and if so the type
of mixed precision being performed.`),qo=i(),be=r("li"),rs=r("strong"),Go=s("num_processes"),Ro=s(" ("),os=r("code"),Wo=s("int"),Vo=s(") \u2014 The number of processes currently launched in parallel."),zo=i(),Ee=r("li"),ns=r("strong"),Uo=s("process_index"),Bo=s(" ("),ls=r("code"),Mo=s("int"),Fo=s(") \u2014 The index of the current process."),Ho=i(),we=r("li"),cs=r("strong"),Jo=s("is_last_process"),Ko=s(" ("),is=r("code"),Qo=s("bool"),Xo=s(") \u2014 Whether or not the current process is the last one."),Yo=i(),ye=r("li"),ps=r("strong"),Zo=s("is_main_process"),en=s(" ("),hs=r("code"),tn=s("bool"),sn=s(") \u2014 Whether or not the current process is the main one."),an=i(),xe=r("li"),ds=r("strong"),rn=s("is_local_main_process"),on=s(" ("),ms=r("code"),nn=s("bool"),ln=s(") \u2014 Whether or not the current process is the main one on the local node."),cn=i(),J=r("div"),v(Ke.$$.fragment),pn=i(),fs=r("p"),hn=s("Lets the local main process go inside a with block."),dn=i(),us=r("p"),mn=s("The other processes will enter the with block after the main process exits."),fn=i(),K=r("div"),v(Qe.$$.fragment),un=i(),gs=r("p"),gn=s("Lets the main process go first inside a with block."),_n=i(),_s=r("p"),vn=s("The other processes will enter the with block after the main process exits."),ua=i(),I=r("div"),v(Xe.$$.fragment),$n=i(),vs=r("p"),bn=s("Singleton class that has information related to gradient synchronization for gradient accumulation"),En=i(),$s=r("p"),bs=r("strong"),wn=s("Available attributes:"),yn=i(),C=r("ul"),je=r("li"),Es=r("strong"),xn=s("end_of_dataloader"),jn=s(" ("),ws=r("code"),Sn=s("bool"),Pn=s(") \u2014 Whether we have reached the end the current dataloader"),Tn=i(),Se=r("li"),ys=r("strong"),kn=s("remainder"),Dn=s(" ("),xs=r("code"),On=s("int"),Ln=s(") \u2014 The number of extra samples that were added from padding the dataloader"),An=i(),Pe=r("li"),js=r("strong"),Cn=s("sync_gradients"),Nn=s(" ("),Ss=r("code"),In=s("bool"),qn=s(") \u2014 Whether the gradients should be synced across all devices"),Gn=i(),Te=r("li"),Ps=r("strong"),Rn=s("active_dataloader"),Wn=s(" ("),Ts=r("code"),Vn=s("Optional[DataLoader]"),zn=s(") \u2014 The dataloader that is currently being iterated over"),Un=i(),ke=r("li"),ks=r("strong"),Bn=s("dataloader_references"),Mn=s(" ("),Ds=r("code"),Fn=s("List[Optional[DataLoader]]"),Hn=s(`) \u2014 A list of references to the dataloaders that are
being iterated over`),Jn=i(),De=r("li"),Os=r("strong"),Kn=s("num_steps"),Qn=s(" ("),Ls=r("code"),Xn=s("int"),Yn=s(") \u2014 The number of steps to accumulate over"),Zn=i(),Oe=r("li"),As=r("strong"),el=s("adjust_scheduler"),tl=s(" ("),Cs=r("code"),sl=s("bool"),al=s(`) \u2014 Whether the scheduler should be adjusted to account for the gradient
accumulation`),this.h()},l(c){const _=Oc('[data-svelte="svelte-1phssyn"]',document.head);d=o(_,"META",{name:!0,content:!0}),_.forEach(t),g=p(c),f=o(c,"H1",{class:!0});var Ye=n(f);h=o(Ye,"A",{id:!0,class:!0,href:!0});var Ns=n(h);u=o(Ns,"SPAN",{});var Is=n(u);$(l.$$.fragment,Is),Is.forEach(t),Ns.forEach(t),m=p(Ye),dt=o(Ye,"SPAN",{});var qs=n(dt);_a=a(qs,"Stateful Classes"),qs.forEach(t),Ye.forEach(t),ha=p(c),Y=o(c,"P",{});var Ze=n(Y);va=a(Ze,"Below are variations of a "),Ge=o(Ze,"A",{href:!0,rel:!0});var Gs=n(Ge);$a=a(Gs,"singleton class"),Gs.forEach(t),ba=a(Ze,` in the sense that all
instances share the same state, which is initialized on the first instantiation.`),Ze.forEach(t),da=p(c),et=o(c,"P",{});var Rs=n(et);Ea=a(Rs,`These classes are immutable and store information about certain configurations or
states.`),Rs.forEach(t),ma=p(c),x=o(c,"DIV",{class:!0});var S=n(x);$(Re.$$.fragment,S),wa=p(S),Q=o(S,"P",{});var at=n(Q);ya=a(at,`Singleton class that has information about the current training environment and functions to help with process
control. Designed to be used when only process control and device execution states are needed. Does `),mt=o(at,"EM",{});var rl=n(mt);xa=a(rl,"not"),rl.forEach(t),ja=a(at,` need to
be initialized from `),ft=o(at,"CODE",{});var ol=n(ft);Sa=a(ol,"Accelerator"),ol.forEach(t),Pa=a(at,"."),at.forEach(t),Ta=p(S),ut=o(S,"P",{});var nl=n(ut);gt=o(nl,"STRONG",{});var ll=n(gt);ka=a(ll,"Available attributes:"),ll.forEach(t),nl.forEach(t),Da=p(S),k=o(S,"UL",{});var L=n(k);Z=o(L,"LI",{});var Ws=n(Z);_t=o(Ws,"STRONG",{});var cl=n(_t);Oa=a(cl,"device"),cl.forEach(t),La=a(Ws," ("),vt=o(Ws,"CODE",{});var il=n(vt);Aa=a(il,"torch.device"),il.forEach(t),Ca=a(Ws,") \u2014 The device to use."),Ws.forEach(t),Na=p(L),ee=o(L,"LI",{});var Vs=n(ee);$t=o(Vs,"STRONG",{});var pl=n($t);Ia=a(pl,"distributed_type"),pl.forEach(t),qa=a(Vs," ("),tt=o(Vs,"A",{href:!0});var hl=n(tt);Ga=a(hl,"DistributedType"),hl.forEach(t),Ra=a(Vs,`) \u2014 The type of distributed environment currently
in use.`),Vs.forEach(t),Wa=p(L),te=o(L,"LI",{});var zs=n(te);bt=o(zs,"STRONG",{});var dl=n(bt);Va=a(dl,"local_process_index"),dl.forEach(t),za=a(zs," ("),Et=o(zs,"CODE",{});var ml=n(Et);Ua=a(ml,"int"),ml.forEach(t),Ba=a(zs,") \u2014 The index of the current process on the current server."),zs.forEach(t),Ma=p(L),se=o(L,"LI",{});var Us=n(se);wt=o(Us,"STRONG",{});var fl=n(wt);Fa=a(fl,"mixed_precision"),fl.forEach(t),Ha=a(Us," ("),yt=o(Us,"CODE",{});var ul=n(yt);Ja=a(ul,"str"),ul.forEach(t),Ka=a(Us,`) \u2014 Whether or not the current script will use mixed precision, and if so the type
of mixed precision being performed.`),Us.forEach(t),Qa=p(L),ae=o(L,"LI",{});var Bs=n(ae);xt=o(Bs,"STRONG",{});var gl=n(xt);Xa=a(gl,"num_processes"),gl.forEach(t),Ya=a(Bs," ("),jt=o(Bs,"CODE",{});var _l=n(jt);Za=a(_l,"int"),_l.forEach(t),er=a(Bs,") \u2014 The number of processes currently launched in parallel."),Bs.forEach(t),tr=p(L),re=o(L,"LI",{});var Ms=n(re);St=o(Ms,"STRONG",{});var vl=n(St);sr=a(vl,"process_index"),vl.forEach(t),ar=a(Ms," ("),Pt=o(Ms,"CODE",{});var $l=n(Pt);rr=a($l,"int"),$l.forEach(t),or=a(Ms,") \u2014 The index of the current process."),Ms.forEach(t),nr=p(L),oe=o(L,"LI",{});var Fs=n(oe);Tt=o(Fs,"STRONG",{});var bl=n(Tt);lr=a(bl,"is_last_process"),bl.forEach(t),cr=a(Fs," ("),kt=o(Fs,"CODE",{});var El=n(kt);ir=a(El,"bool"),El.forEach(t),pr=a(Fs,") \u2014 Whether or not the current process is the last one."),Fs.forEach(t),hr=p(L),ne=o(L,"LI",{});var Hs=n(ne);Dt=o(Hs,"STRONG",{});var wl=n(Dt);dr=a(wl,"is_main_process"),wl.forEach(t),mr=a(Hs," ("),Ot=o(Hs,"CODE",{});var yl=n(Ot);fr=a(yl,"bool"),yl.forEach(t),ur=a(Hs,") \u2014 Whether or not the current process is the main one."),Hs.forEach(t),gr=p(L),le=o(L,"LI",{});var Js=n(le);Lt=o(Js,"STRONG",{});var xl=n(Lt);_r=a(xl,"is_local_main_process"),xl.forEach(t),vr=a(Js," ("),At=o(Js,"CODE",{});var jl=n(At);$r=a(jl,"bool"),jl.forEach(t),br=a(Js,") \u2014 Whether or not the current process is the main one on the local node."),Js.forEach(t),L.forEach(t),Er=p(S),G=o(S,"DIV",{class:!0});var Le=n(G);$(We.$$.fragment,Le),wr=p(Le),Ct=o(Le,"P",{});var Sl=n(Ct);yr=a(Sl,"Lets the local main process go inside a with block."),Sl.forEach(t),xr=p(Le),Nt=o(Le,"P",{});var Pl=n(Nt);jr=a(Pl,"The other processes will enter the with block after the main process exits."),Pl.forEach(t),Sr=p(Le),$(ce.$$.fragment,Le),Le.forEach(t),Pr=p(S),R=o(S,"DIV",{class:!0});var Ae=n(R);$(Ve.$$.fragment,Ae),Tr=p(Ae),It=o(Ae,"P",{});var Tl=n(It);kr=a(Tl,"Lets the main process go first inside a with block."),Tl.forEach(t),Dr=p(Ae),qt=o(Ae,"P",{});var kl=n(qt);Or=a(kl,"The other processes will enter the with block after the main process exits."),kl.forEach(t),Lr=p(Ae),$(ie.$$.fragment,Ae),Ae.forEach(t),Ar=p(S),z=o(S,"DIV",{class:!0});var rt=n(z);$(ze.$$.fragment,rt),Cr=p(rt),Gt=o(rt,"P",{});var Dl=n(Gt);Nr=a(Dl,"Decorator that only runs the decorated function on the last process."),Dl.forEach(t),Ir=p(rt),$(pe.$$.fragment,rt),rt.forEach(t),qr=p(S),U=o(S,"DIV",{class:!0});var ot=n(U);$(Ue.$$.fragment,ot),Gr=p(ot),Rt=o(ot,"P",{});var Ol=n(Rt);Rr=a(Ol,"Decorator that only runs the decorated function on the local main process."),Ol.forEach(t),Wr=p(ot),$(he.$$.fragment,ot),ot.forEach(t),Vr=p(S),B=o(S,"DIV",{class:!0});var nt=n(B);$(Be.$$.fragment,nt),zr=p(nt),Wt=o(nt,"P",{});var Ll=n(Wt);Ur=a(Ll,"Decorator that only runs the decorated function on the process with the given index on the current node."),Ll.forEach(t),Br=p(nt),$(de.$$.fragment,nt),nt.forEach(t),Mr=p(S),M=o(S,"DIV",{class:!0});var lt=n(M);$(Me.$$.fragment,lt),Fr=p(lt),Vt=o(lt,"P",{});var Al=n(Vt);Hr=a(Al,"Decorator that only runs the decorated function on the main process."),Al.forEach(t),Jr=p(lt),$(me.$$.fragment,lt),lt.forEach(t),Kr=p(S),F=o(S,"DIV",{class:!0});var ct=n(F);$(Fe.$$.fragment,ct),Qr=p(ct),zt=o(ct,"P",{});var Cl=n(zt);Xr=a(Cl,"Decorator that only runs the decorated function on the process with the given index."),Cl.forEach(t),Yr=p(ct),$(fe.$$.fragment,ct),ct.forEach(t),Zr=p(S),H=o(S,"DIV",{class:!0});var it=n(H);$(He.$$.fragment,it),eo=p(it),Ut=o(it,"P",{});var Nl=n(Ut);to=a(Nl,`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),Nl.forEach(t),so=p(it),$(ue.$$.fragment,it),it.forEach(t),S.forEach(t),fa=p(c),A=o(c,"DIV",{class:!0});var V=n(A);$(Je.$$.fragment,V),ao=p(V),Bt=o(V,"P",{});var Il=n(Bt);ro=a(Il,"Singleton class that has information about the current training environment."),Il.forEach(t),oo=p(V),Mt=o(V,"P",{});var ql=n(Mt);Ft=o(ql,"STRONG",{});var Gl=n(Ft);no=a(Gl,"Available attributes:"),Gl.forEach(t),ql.forEach(t),lo=p(V),P=o(V,"UL",{});var D=n(P);ge=o(D,"LI",{});var Ks=n(ge);Ht=o(Ks,"STRONG",{});var Rl=n(Ht);co=a(Rl,"device"),Rl.forEach(t),io=a(Ks," ("),Jt=o(Ks,"CODE",{});var Wl=n(Jt);po=a(Wl,"torch.device"),Wl.forEach(t),ho=a(Ks,") \u2014 The device to use."),Ks.forEach(t),mo=p(D),_e=o(D,"LI",{});var Qs=n(_e);Kt=o(Qs,"STRONG",{});var Vl=n(Kt);fo=a(Vl,"distributed_type"),Vl.forEach(t),uo=a(Qs," ("),st=o(Qs,"A",{href:!0});var zl=n(st);go=a(zl,"DistributedType"),zl.forEach(t),_o=a(Qs,`) \u2014 The type of distributed environment currently
in use.`),Qs.forEach(t),vo=p(D),W=o(D,"LI",{});var X=n(W);Qt=o(X,"STRONG",{});var Ul=n(Qt);$o=a(Ul,"initialized"),Ul.forEach(t),bo=a(X," ("),Xt=o(X,"CODE",{});var Bl=n(Xt);Eo=a(Bl,"bool"),Bl.forEach(t),wo=a(X,") \u2014 Whether or not the "),Yt=o(X,"CODE",{});var Ml=n(Yt);yo=a(Ml,"AcceleratorState"),Ml.forEach(t),xo=a(X," has been initialized from "),Zt=o(X,"CODE",{});var Fl=n(Zt);jo=a(Fl,"Accelerator"),Fl.forEach(t),So=a(X,"."),X.forEach(t),Po=p(D),ve=o(D,"LI",{});var Xs=n(ve);es=o(Xs,"STRONG",{});var Hl=n(es);To=a(Hl,"local_process_index"),Hl.forEach(t),ko=a(Xs," ("),ts=o(Xs,"CODE",{});var Jl=n(ts);Do=a(Jl,"int"),Jl.forEach(t),Oo=a(Xs,") \u2014 The index of the current process on the current server."),Xs.forEach(t),Lo=p(D),$e=o(D,"LI",{});var Ys=n($e);ss=o(Ys,"STRONG",{});var Kl=n(ss);Ao=a(Kl,"mixed_precision"),Kl.forEach(t),Co=a(Ys," ("),as=o(Ys,"CODE",{});var Ql=n(as);No=a(Ql,"str"),Ql.forEach(t),Io=a(Ys,`) \u2014 Whether or not the current script will use mixed precision, and if so the type
of mixed precision being performed.`),Ys.forEach(t),qo=p(D),be=o(D,"LI",{});var Zs=n(be);rs=o(Zs,"STRONG",{});var Xl=n(rs);Go=a(Xl,"num_processes"),Xl.forEach(t),Ro=a(Zs," ("),os=o(Zs,"CODE",{});var Yl=n(os);Wo=a(Yl,"int"),Yl.forEach(t),Vo=a(Zs,") \u2014 The number of processes currently launched in parallel."),Zs.forEach(t),zo=p(D),Ee=o(D,"LI",{});var ea=n(Ee);ns=o(ea,"STRONG",{});var Zl=n(ns);Uo=a(Zl,"process_index"),Zl.forEach(t),Bo=a(ea," ("),ls=o(ea,"CODE",{});var ec=n(ls);Mo=a(ec,"int"),ec.forEach(t),Fo=a(ea,") \u2014 The index of the current process."),ea.forEach(t),Ho=p(D),we=o(D,"LI",{});var ta=n(we);cs=o(ta,"STRONG",{});var tc=n(cs);Jo=a(tc,"is_last_process"),tc.forEach(t),Ko=a(ta," ("),is=o(ta,"CODE",{});var sc=n(is);Qo=a(sc,"bool"),sc.forEach(t),Xo=a(ta,") \u2014 Whether or not the current process is the last one."),ta.forEach(t),Yo=p(D),ye=o(D,"LI",{});var sa=n(ye);ps=o(sa,"STRONG",{});var ac=n(ps);Zo=a(ac,"is_main_process"),ac.forEach(t),en=a(sa," ("),hs=o(sa,"CODE",{});var rc=n(hs);tn=a(rc,"bool"),rc.forEach(t),sn=a(sa,") \u2014 Whether or not the current process is the main one."),sa.forEach(t),an=p(D),xe=o(D,"LI",{});var aa=n(xe);ds=o(aa,"STRONG",{});var oc=n(ds);rn=a(oc,"is_local_main_process"),oc.forEach(t),on=a(aa," ("),ms=o(aa,"CODE",{});var nc=n(ms);nn=a(nc,"bool"),nc.forEach(t),ln=a(aa,") \u2014 Whether or not the current process is the main one on the local node."),aa.forEach(t),D.forEach(t),cn=p(V),J=o(V,"DIV",{class:!0});var pt=n(J);$(Ke.$$.fragment,pt),pn=p(pt),fs=o(pt,"P",{});var lc=n(fs);hn=a(lc,"Lets the local main process go inside a with block."),lc.forEach(t),dn=p(pt),us=o(pt,"P",{});var cc=n(us);mn=a(cc,"The other processes will enter the with block after the main process exits."),cc.forEach(t),pt.forEach(t),fn=p(V),K=o(V,"DIV",{class:!0});var ht=n(K);$(Qe.$$.fragment,ht),un=p(ht),gs=o(ht,"P",{});var ic=n(gs);gn=a(ic,"Lets the main process go first inside a with block."),ic.forEach(t),_n=p(ht),_s=o(ht,"P",{});var pc=n(_s);vn=a(pc,"The other processes will enter the with block after the main process exits."),pc.forEach(t),ht.forEach(t),V.forEach(t),ua=p(c),I=o(c,"DIV",{class:!0});var Ce=n(I);$(Xe.$$.fragment,Ce),$n=p(Ce),vs=o(Ce,"P",{});var hc=n(vs);bn=a(hc,"Singleton class that has information related to gradient synchronization for gradient accumulation"),hc.forEach(t),En=p(Ce),$s=o(Ce,"P",{});var dc=n($s);bs=o(dc,"STRONG",{});var mc=n(bs);wn=a(mc,"Available attributes:"),mc.forEach(t),dc.forEach(t),yn=p(Ce),C=o(Ce,"UL",{});var N=n(C);je=o(N,"LI",{});var ra=n(je);Es=o(ra,"STRONG",{});var fc=n(Es);xn=a(fc,"end_of_dataloader"),fc.forEach(t),jn=a(ra," ("),ws=o(ra,"CODE",{});var uc=n(ws);Sn=a(uc,"bool"),uc.forEach(t),Pn=a(ra,") \u2014 Whether we have reached the end the current dataloader"),ra.forEach(t),Tn=p(N),Se=o(N,"LI",{});var oa=n(Se);ys=o(oa,"STRONG",{});var gc=n(ys);kn=a(gc,"remainder"),gc.forEach(t),Dn=a(oa," ("),xs=o(oa,"CODE",{});var _c=n(xs);On=a(_c,"int"),_c.forEach(t),Ln=a(oa,") \u2014 The number of extra samples that were added from padding the dataloader"),oa.forEach(t),An=p(N),Pe=o(N,"LI",{});var na=n(Pe);js=o(na,"STRONG",{});var vc=n(js);Cn=a(vc,"sync_gradients"),vc.forEach(t),Nn=a(na," ("),Ss=o(na,"CODE",{});var $c=n(Ss);In=a($c,"bool"),$c.forEach(t),qn=a(na,") \u2014 Whether the gradients should be synced across all devices"),na.forEach(t),Gn=p(N),Te=o(N,"LI",{});var la=n(Te);Ps=o(la,"STRONG",{});var bc=n(Ps);Rn=a(bc,"active_dataloader"),bc.forEach(t),Wn=a(la," ("),Ts=o(la,"CODE",{});var Ec=n(Ts);Vn=a(Ec,"Optional[DataLoader]"),Ec.forEach(t),zn=a(la,") \u2014 The dataloader that is currently being iterated over"),la.forEach(t),Un=p(N),ke=o(N,"LI",{});var ca=n(ke);ks=o(ca,"STRONG",{});var wc=n(ks);Bn=a(wc,"dataloader_references"),wc.forEach(t),Mn=a(ca," ("),Ds=o(ca,"CODE",{});var yc=n(Ds);Fn=a(yc,"List[Optional[DataLoader]]"),yc.forEach(t),Hn=a(ca,`) \u2014 A list of references to the dataloaders that are
being iterated over`),ca.forEach(t),Jn=p(N),De=o(N,"LI",{});var ia=n(De);Os=o(ia,"STRONG",{});var xc=n(Os);Kn=a(xc,"num_steps"),xc.forEach(t),Qn=a(ia," ("),Ls=o(ia,"CODE",{});var jc=n(Ls);Xn=a(jc,"int"),jc.forEach(t),Yn=a(ia,") \u2014 The number of steps to accumulate over"),ia.forEach(t),Zn=p(N),Oe=o(N,"LI",{});var pa=n(Oe);As=o(pa,"STRONG",{});var Sc=n(As);el=a(Sc,"adjust_scheduler"),Sc.forEach(t),tl=a(pa," ("),Cs=o(pa,"CODE",{});var Pc=n(Cs);sl=a(Pc,"bool"),Pc.forEach(t),al=a(pa,`) \u2014 Whether the scheduler should be adjusted to account for the gradient
accumulation`),pa.forEach(t),N.forEach(t),Ce.forEach(t),this.h()},h(){T(d,"name","hf:doc:metadata"),T(d,"content",JSON.stringify(Uc)),T(h,"id","accelerate.PartialState"),T(h,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),T(h,"href","#accelerate.PartialState"),T(f,"class","relative group"),T(Ge,"href","https://en.wikipedia.org/wiki/Singleton_pattern"),T(Ge,"rel","nofollow"),T(tt,"href","/docs/accelerate/v0.19.0/en/package_reference/utilities#accelerate.DistributedType"),T(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(st,"href","/docs/accelerate/v0.19.0/en/package_reference/utilities#accelerate.DistributedType"),T(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(c,_){e(document.head,d),j(c,g,_),j(c,f,_),e(f,h),e(h,u),b(l,u,null),e(f,m),e(f,dt),e(dt,_a),j(c,ha,_),j(c,Y,_),e(Y,va),e(Y,Ge),e(Ge,$a),e(Y,ba),j(c,da,_),j(c,et,_),e(et,Ea),j(c,ma,_),j(c,x,_),b(Re,x,null),e(x,wa),e(x,Q),e(Q,ya),e(Q,mt),e(mt,xa),e(Q,ja),e(Q,ft),e(ft,Sa),e(Q,Pa),e(x,Ta),e(x,ut),e(ut,gt),e(gt,ka),e(x,Da),e(x,k),e(k,Z),e(Z,_t),e(_t,Oa),e(Z,La),e(Z,vt),e(vt,Aa),e(Z,Ca),e(k,Na),e(k,ee),e(ee,$t),e($t,Ia),e(ee,qa),e(ee,tt),e(tt,Ga),e(ee,Ra),e(k,Wa),e(k,te),e(te,bt),e(bt,Va),e(te,za),e(te,Et),e(Et,Ua),e(te,Ba),e(k,Ma),e(k,se),e(se,wt),e(wt,Fa),e(se,Ha),e(se,yt),e(yt,Ja),e(se,Ka),e(k,Qa),e(k,ae),e(ae,xt),e(xt,Xa),e(ae,Ya),e(ae,jt),e(jt,Za),e(ae,er),e(k,tr),e(k,re),e(re,St),e(St,sr),e(re,ar),e(re,Pt),e(Pt,rr),e(re,or),e(k,nr),e(k,oe),e(oe,Tt),e(Tt,lr),e(oe,cr),e(oe,kt),e(kt,ir),e(oe,pr),e(k,hr),e(k,ne),e(ne,Dt),e(Dt,dr),e(ne,mr),e(ne,Ot),e(Ot,fr),e(ne,ur),e(k,gr),e(k,le),e(le,Lt),e(Lt,_r),e(le,vr),e(le,At),e(At,$r),e(le,br),e(x,Er),e(x,G),b(We,G,null),e(G,wr),e(G,Ct),e(Ct,yr),e(G,xr),e(G,Nt),e(Nt,jr),e(G,Sr),b(ce,G,null),e(x,Pr),e(x,R),b(Ve,R,null),e(R,Tr),e(R,It),e(It,kr),e(R,Dr),e(R,qt),e(qt,Or),e(R,Lr),b(ie,R,null),e(x,Ar),e(x,z),b(ze,z,null),e(z,Cr),e(z,Gt),e(Gt,Nr),e(z,Ir),b(pe,z,null),e(x,qr),e(x,U),b(Ue,U,null),e(U,Gr),e(U,Rt),e(Rt,Rr),e(U,Wr),b(he,U,null),e(x,Vr),e(x,B),b(Be,B,null),e(B,zr),e(B,Wt),e(Wt,Ur),e(B,Br),b(de,B,null),e(x,Mr),e(x,M),b(Me,M,null),e(M,Fr),e(M,Vt),e(Vt,Hr),e(M,Jr),b(me,M,null),e(x,Kr),e(x,F),b(Fe,F,null),e(F,Qr),e(F,zt),e(zt,Xr),e(F,Yr),b(fe,F,null),e(x,Zr),e(x,H),b(He,H,null),e(H,eo),e(H,Ut),e(Ut,to),e(H,so),b(ue,H,null),j(c,fa,_),j(c,A,_),b(Je,A,null),e(A,ao),e(A,Bt),e(Bt,ro),e(A,oo),e(A,Mt),e(Mt,Ft),e(Ft,no),e(A,lo),e(A,P),e(P,ge),e(ge,Ht),e(Ht,co),e(ge,io),e(ge,Jt),e(Jt,po),e(ge,ho),e(P,mo),e(P,_e),e(_e,Kt),e(Kt,fo),e(_e,uo),e(_e,st),e(st,go),e(_e,_o),e(P,vo),e(P,W),e(W,Qt),e(Qt,$o),e(W,bo),e(W,Xt),e(Xt,Eo),e(W,wo),e(W,Yt),e(Yt,yo),e(W,xo),e(W,Zt),e(Zt,jo),e(W,So),e(P,Po),e(P,ve),e(ve,es),e(es,To),e(ve,ko),e(ve,ts),e(ts,Do),e(ve,Oo),e(P,Lo),e(P,$e),e($e,ss),e(ss,Ao),e($e,Co),e($e,as),e(as,No),e($e,Io),e(P,qo),e(P,be),e(be,rs),e(rs,Go),e(be,Ro),e(be,os),e(os,Wo),e(be,Vo),e(P,zo),e(P,Ee),e(Ee,ns),e(ns,Uo),e(Ee,Bo),e(Ee,ls),e(ls,Mo),e(Ee,Fo),e(P,Ho),e(P,we),e(we,cs),e(cs,Jo),e(we,Ko),e(we,is),e(is,Qo),e(we,Xo),e(P,Yo),e(P,ye),e(ye,ps),e(ps,Zo),e(ye,en),e(ye,hs),e(hs,tn),e(ye,sn),e(P,an),e(P,xe),e(xe,ds),e(ds,rn),e(xe,on),e(xe,ms),e(ms,nn),e(xe,ln),e(A,cn),e(A,J),b(Ke,J,null),e(J,pn),e(J,fs),e(fs,hn),e(J,dn),e(J,us),e(us,mn),e(A,fn),e(A,K),b(Qe,K,null),e(K,un),e(K,gs),e(gs,gn),e(K,_n),e(K,_s),e(_s,vn),j(c,ua,_),j(c,I,_),b(Xe,I,null),e(I,$n),e(I,vs),e(vs,bn),e(I,En),e(I,$s),e($s,bs),e(bs,wn),e(I,yn),e(I,C),e(C,je),e(je,Es),e(Es,xn),e(je,jn),e(je,ws),e(ws,Sn),e(je,Pn),e(C,Tn),e(C,Se),e(Se,ys),e(ys,kn),e(Se,Dn),e(Se,xs),e(xs,On),e(Se,Ln),e(C,An),e(C,Pe),e(Pe,js),e(js,Cn),e(Pe,Nn),e(Pe,Ss),e(Ss,In),e(Pe,qn),e(C,Gn),e(C,Te),e(Te,Ps),e(Ps,Rn),e(Te,Wn),e(Te,Ts),e(Ts,Vn),e(Te,zn),e(C,Un),e(C,ke),e(ke,ks),e(ks,Bn),e(ke,Mn),e(ke,Ds),e(Ds,Fn),e(ke,Hn),e(C,Jn),e(C,De),e(De,Os),e(Os,Kn),e(De,Qn),e(De,Ls),e(Ls,Xn),e(De,Yn),e(C,Zn),e(C,Oe),e(Oe,As),e(As,el),e(Oe,tl),e(Oe,Cs),e(Cs,sl),e(Oe,al),ga=!0},p(c,[_]){const Ye={};_&2&&(Ye.$$scope={dirty:_,ctx:c}),ce.$set(Ye);const Ns={};_&2&&(Ns.$$scope={dirty:_,ctx:c}),ie.$set(Ns);const Is={};_&2&&(Is.$$scope={dirty:_,ctx:c}),pe.$set(Is);const qs={};_&2&&(qs.$$scope={dirty:_,ctx:c}),he.$set(qs);const Ze={};_&2&&(Ze.$$scope={dirty:_,ctx:c}),de.$set(Ze);const Gs={};_&2&&(Gs.$$scope={dirty:_,ctx:c}),me.$set(Gs);const Rs={};_&2&&(Rs.$$scope={dirty:_,ctx:c}),fe.$set(Rs);const S={};_&2&&(S.$$scope={dirty:_,ctx:c}),ue.$set(S)},i(c){ga||(E(l.$$.fragment,c),E(Re.$$.fragment,c),E(We.$$.fragment,c),E(ce.$$.fragment,c),E(Ve.$$.fragment,c),E(ie.$$.fragment,c),E(ze.$$.fragment,c),E(pe.$$.fragment,c),E(Ue.$$.fragment,c),E(he.$$.fragment,c),E(Be.$$.fragment,c),E(de.$$.fragment,c),E(Me.$$.fragment,c),E(me.$$.fragment,c),E(Fe.$$.fragment,c),E(fe.$$.fragment,c),E(He.$$.fragment,c),E(ue.$$.fragment,c),E(Je.$$.fragment,c),E(Ke.$$.fragment,c),E(Qe.$$.fragment,c),E(Xe.$$.fragment,c),ga=!0)},o(c){w(l.$$.fragment,c),w(Re.$$.fragment,c),w(We.$$.fragment,c),w(ce.$$.fragment,c),w(Ve.$$.fragment,c),w(ie.$$.fragment,c),w(ze.$$.fragment,c),w(pe.$$.fragment,c),w(Ue.$$.fragment,c),w(he.$$.fragment,c),w(Be.$$.fragment,c),w(de.$$.fragment,c),w(Me.$$.fragment,c),w(me.$$.fragment,c),w(Fe.$$.fragment,c),w(fe.$$.fragment,c),w(He.$$.fragment,c),w(ue.$$.fragment,c),w(Je.$$.fragment,c),w(Ke.$$.fragment,c),w(Qe.$$.fragment,c),w(Xe.$$.fragment,c),ga=!1},d(c){t(d),c&&t(g),c&&t(f),y(l),c&&t(ha),c&&t(Y),c&&t(da),c&&t(et),c&&t(ma),c&&t(x),y(Re),y(We),y(ce),y(Ve),y(ie),y(ze),y(pe),y(Ue),y(he),y(Be),y(de),y(Me),y(me),y(Fe),y(fe),y(He),y(ue),c&&t(fa),c&&t(A),y(Je),y(Ke),y(Qe),c&&t(ua),c&&t(I),y(Xe)}}}const Uc={local:"accelerate.PartialState",title:"Stateful Classes"};function Bc(O){return Lc(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Qc extends Tc{constructor(d){super();kc(this,d,Bc,zc,Dc,{})}}export{Qc as default,Uc as metadata};
